import java.awt.geom.*;
/**
  This class represents a unit of area (2ft X 2ft) on the 2nd floor of Nedderman Hall.


 * @author Ashwini Kuntamukkala
 * @version 	%I%, %G%
 * @since       JDK1.2

*/

public class Cell_Client
{
	double x;
	double y;
	public static int SCALE=6;

/**
   Sets the upper left coordinate to zero

 * @author Ashwini Kuntamukkala
 * @version 	%I%, %G%
 * @since       JDK1.2

*/

	public Cell_Client()
	{
		x = y = 0;
	}
/**
	Sets the upper left coordinate to a point
 * @author Ashwini Kuntamukkala
 * @version 	%I%, %G%
 * @since       JDK1.2

*/

	public Cell_Client(Point2D p)
	{
	 x = Math.floor(p.getX()/SCALE);
	 y = Math.floor(p.getY()/SCALE);
	}
/**
	Sets the upper left coordinate to a point
 * @author Ashwini Kuntamukkala
 * @version 	%I%, %G%
 * @since       JDK1.2

*/

	public Cell_Client(double x1, double y1)
	{
	 x = Math.floor(x1/SCALE);
	 y = Math.floor(y1/SCALE);
	}
/**
 Returns the bounding rectangle for a particular cell
 * @author Ashwini Kuntamukkala
 * @version 	%I%, %G%
 * @since       JDK1.2

*/

	public Rectangle2D getBoundingRectangle()
	{
		return new Rectangle2D.Double(x*SCALE,y*SCALE,SCALE,SCALE);
	}
/**
	Returns the top left coordinate of a cell
 * @author Ashwini Kuntamukkala
 * @version 	%I%, %G%
 * @since       JDK1.2

*/

	public Point2D topLeftCoordinate()
	{
		return new Point2D.Double(x*SCALE,y*SCALE);
	}
/**
  Returns the string version of the cell
 * @author Ashwini Kuntamukkala
 * @version 	%I%, %G%
 * @since       JDK1.2

*/

	public String toString()
	{
		return new String("Cell : [" + Double.toString(x) + "," + Double.toString(y) + "]");
	}


	public int getX() { return (int) x; }
	public int getY() { return (int) y; }

	public void setX(double a ) {  x = a; }
	public void setY(double b ) {  y = b; }

}