import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import wPercept.*;

public class G_Client extends JFrame
{
	private JMenuBar  bar;
	private JMenu     planMenu;
	private JMenuItem planMnuItem;
	private JMenuItem exitMnuItem;

	private JMenu     perceptMenu;
	private JMenuItem perceptMenuItem;

	private String    wwServerIP = "127.0.0.1";
	private String    portNumber = "5000";

	private String   client;
	private String   wwAgent;

	private ClientDisplay cd;

	private JTextField tf_wwServerIP;
	private JTextField tf_wwServerPort;
	private JButton    btn_Connect;

	private JRadioButton rb_Human;
	private JRadioButton rb_swAgent;
	private JRadioButton rb_Robot;

	private JRadioButton rb_HumanClient;
	private JRadioButton rb_swClient;

	private Frame1 perceptFrame;

	private ObjectInputStream input;
	private ObjectOutputStream output;

	private ClientThread cThread;

	public Client()
	{
		super("Agent");
		Container c = getContentPane();
		bar = new JMenuBar();
		planMenu = new JMenu();
		planMenu.setText("Plan");
		planMnuItem = new JMenuItem();
		planMenu.add(planMnuItem);
		planMnuItem.setText("Display Layout");
		cd = null;
		exitMnuItem = new JMenuItem();
		exitMnuItem.setText("Exit");

		exitMnuItem.addActionListener(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					System.exit(0);
				}
			}
			);

		planMenu.add(exitMnuItem);
		c.setLayout(new BorderLayout());
		setJMenuBar(bar);
		bar.add(planMenu);

		perceptMenu = new JMenu();
		perceptMenu.setText("Percept");
		perceptMenuItem = new JMenuItem("Display Percepts");
		perceptMenu.add(perceptMenuItem);
		bar.add(perceptMenu);


		addWindowListener(
			new WindowAdapter()
			{
				public void windowClosing(WindowEvent e)
				{
					System.exit(0);
				}
			}
			);
		ActionHandler handler = new ActionHandler();
		planMnuItem.addActionListener(handler);
		getContentPane().setLayout(null);
		JLabel label1 = new JLabel("Wumpus World Server IP: ", JLabel.RIGHT);
		label1.setBounds(25,25,150,20);
		getContentPane().add(label1);
		JLabel label2 = new JLabel("Port #: ", JLabel.RIGHT);
		label2.setBounds(25,55,150,20);
		getContentPane().add(label2);

		tf_wwServerIP = new JTextField();
		tf_wwServerIP.setText(wwServerIP);
		tf_wwServerIP.setBounds(180,25, 100,20);
		getContentPane().add(tf_wwServerIP);
		tf_wwServerPort = new JTextField();
		tf_wwServerPort.setText(portNumber);
		tf_wwServerPort.setBounds(180,55,100,20);
		getContentPane().add(tf_wwServerPort);

		btn_Connect = new JButton("Connect");
		btn_Connect.setBounds(180,240,100,25);
		getContentPane().add(btn_Connect);

		btn_Connect.addActionListener(handler);

		perceptMenuItem.addActionListener(handler);
		JLabel label3 = new JLabel("Agent in wumpus world...");
		label3.setBounds(25,95, 175, 20);
		getContentPane().add(label3);
		JPanel panel = new JPanel();
		panel.setBounds(25, 115, 255, 30);
		getContentPane().add(panel);


		ButtonGroup bg = new ButtonGroup();
		rb_Human = new JRadioButton("Human");
		rb_swAgent = new JRadioButton("S/W Agent");
		rb_Robot = new JRadioButton("Robot");

		bg.add(rb_Human);
		bg.add(rb_swAgent);
		bg.add(rb_Robot);

		rb_swAgent.setSelected(true);
		rb_Human.setBounds(5,5,75,20);
		rb_Robot.setBounds(85,5,75,20);
		rb_swAgent.setBounds(160,5,90,20);

		panel.setLayout(null);
		panel.add(rb_Human);
		panel.add(rb_swAgent);
		panel.add(rb_Robot);

		JLabel label13 = new JLabel("Client is ...");
		label13.setBounds(25,170, 175, 20);
		getContentPane().add(label13);
		JPanel panel1 = new JPanel();
		panel1.setBounds(25, 195, 255, 30);
		getContentPane().add(panel1);


		ButtonGroup bg1 = new ButtonGroup();
		rb_HumanClient = new JRadioButton("Human");
		rb_swClient = new JRadioButton("S/W Agent");

		bg1.add(rb_HumanClient);
		bg1.add(rb_swClient);

		rb_HumanClient.setSelected(true);
		rb_HumanClient.setBounds(5,5,75,20);
		rb_swClient.setBounds(85,5,90,20);

		panel1.setLayout(null);
		panel1.add(rb_HumanClient);
		panel1.add(rb_swClient);

		perceptFrame = new Frame1();
		cd = new ClientDisplay();
		setMenuItems();
		pack();
		validate();
	}

	public void setMenuItems()
	{
		perceptMenuItem.setEnabled(false);
	}

	public void setMenuItemsGS()
	{
		perceptMenuItem.setEnabled(true);
		rb_Human.setEnabled(false);
		rb_swAgent.setEnabled(false);
		rb_Robot.setEnabled(false);

		rb_HumanClient.setEnabled(false);
		rb_swClient.setEnabled(false);
	}

	public void setMenuItemsGE()
	{
		perceptMenuItem.setEnabled(false);
		rb_Human.setEnabled(true);
		rb_swAgent.setEnabled(true);
		rb_Robot.setEnabled(true);

		rb_HumanClient.setEnabled(true);
		rb_swClient.setEnabled(true);

	}
	private class ActionHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			if(e.getSource()==planMnuItem)
			{
				if(planMnuItem.getText().equals("Display Layout"))
				{


					cd.setSize(675,680);
					cd.show();


				}
				else
				{
					cd.hide();
					planMnuItem.setText("Display Layout");
				}


			}

			if(e.getSource()==btn_Connect)
			{
				if(btn_Connect.getText().equals("Connect"))
				{
					try
					{

						if(rb_HumanClient.isSelected())
						{
							client = new String("Human");
						}
						else
						{
							client = new String("s/w Agent");
						}

						if(rb_Human.isSelected())
						{
							wwAgent = new String("Human");
						}
						else
						{
							if(rb_Robot.isSelected())
							{
								wwAgent = new String("Robot");
							}
							else
							{
								wwAgent = new String("s/w Agent");
							}
						}
						int portNo = Integer.parseInt(tf_wwServerPort.getText());
						Socket socket = new Socket(InetAddress.getByName(tf_wwServerIP.getText()), portNo);

						cThread = new ClientThread(socket);
						cThread.start();
						btn_Connect.setText("Disconnect");
						setMenuItemsGS();



					}
					catch(NumberFormatException e2)
					{
						JOptionPane.showMessageDialog(null, "Please enter an integer greater than zero for port number");

					}
					catch(IOException e1)
					{
						JOptionPane.showMessageDialog(null, "Invalid IP address of Wumpus World Server. Please check");
					}

				}
				else
				{
					btn_Connect.setText("Connect");
					setMenuItemsGE();
					perceptFrame.hide();
					cd.hide();
				}
			}

			if(e.getSource()==perceptMenuItem)
			{
				if(client.equals("s/w Agent"))
				{
					perceptFrame.setSW_Agent(false);
				}
				else
				{
					perceptFrame.setSW_Agent(true);
				}
				perceptFrame.setSize(600,470);
				perceptFrame.setVisible(true);
			}

		}


	}

	private class ClientThread extends Thread
	{
		Socket socket;

		public ClientThread(Socket s)
		{
			socket = s;
			try
			{
				output = new ObjectOutputStream(socket.getOutputStream());
				input  = new ObjectInputStream(socket.getInputStream());
			}
			catch(IOException e)
			{
			}
		}

		public void run()
		{

			String message;
			try
			{
				output.writeObject("\tClient : " + client + ", Wumpus World Agent : " + wwAgent);
				output.flush();
				message = (String) input.readObject();
				if(message.equals("Game in progress"))
				{
					JOptionPane.showMessageDialog(null,"Game is in progress, check back later....");
					output.close();
					input.close();
					return;
				}
				else
				{
					JOptionPane.showMessageDialog(null, message);
					do
					{
						try
						{
							message = (String)input.readObject();
							System.out.println(message);
							if(message.equals("SERVER >> TERMINATE"))
							{

								JOptionPane.showMessageDialog(null, "Server terminated connection!!");
							}
							else
							{
								wPercept.TransferPercept t = (wPercept.TransferPercept) input.readObject();
								if(t.getStench())
								{
									perceptFrame.setStenchText("Yes");
								}
								else
								{
									perceptFrame.setStenchText("No");
								}
								if(t.getBreeze())
								{
									perceptFrame.setBreezeText("Yes");
								}
								else
								{
									perceptFrame.setBreezeText("No");
								}
								if(t.getGlitter())
								{
									perceptFrame.setGlitterText("Yes");
								}
								else
								{
									perceptFrame.setGlitterText("No");
								}
								if(t.getBump())
								{
									perceptFrame.setBumpText("Yes");
								}
								else
								{
									perceptFrame.setBumpText("No");
								}

							}

						}
						catch(ClassNotFoundException cnfex)
						{

						}
					} while(!message.equals("SERVER >> TERMINATE"));
					btn_Connect.setText("Connect");
					setMenuItemsGE();
					perceptFrame.hide();
					cd.hide();

				}
			}
			catch(ClassNotFoundException cnfex)
			{
			}
			catch(IOException ioex)
			{

			}


		}
	}
	public static void main(String args[])
	{
		Client c = new Client();
		c.setSize(300,330);
		c.show();

	}


}