import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.image.*;
import java.util.*;
import java.io.*;
import java.awt.geom.*;

public class ClientDisplayPanel extends JPanel
{
	private GeneralPath path;
	private Vector[] vPoints;
	private Vector[] vObstacles;
	private int nValidPolygons;
	private int nInvalidPolygons;
	private GeneralPath[] validPath;
	private GeneralPath[] invalidPath;
	private int nWidth;
	private int nHeight;
	private JLabel statusBar;
    private Cell_Client defStartLoc;
    private Cell_Client currentLoc;
    public static int SCALE = 24;
    private GetOrientation go;

	private ImageIcon mapImage;
	private int orientation;
	private int orgOrientation;
	public ClientDisplayPanel(JLabel s)
	{
		statusBar = s;
		setBackground(Color.black);
		fileRead("plan.txt","obstacle.txt");
		constructPlan();
		constructObstacles();
		mapImage = new ImageIcon("direction.gif");
		defStartLoc = null;
		go = null;
		addMouseMotionListener(new MouseMotionHandler());
		addMouseListener(new MouseClickHandler());

	}

	public void setCrossHairCursor()
	{
		setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
	}

	public void setDefaultCursor()
	{
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	}
	   public void constructObstacles()
	   {
		   invalidPath = new GeneralPath[nInvalidPolygons];
		   int i,j;
		   for(i = 0; i < nInvalidPolygons; i++)
		   {

			   invalidPath[i] = new GeneralPath(GeneralPath.WIND_EVEN_ODD);
			   Point2D p = (Point2D) vObstacles[i].elementAt(0);
			   Point2D p1;
			   invalidPath[i].moveTo((float)p.getX(),(float) p.getY());
			   for(j = 1; j < vObstacles[i].size(); j++)
			   {
				   p1 = (Point2D) vObstacles[i].elementAt(j);
				   invalidPath[i].lineTo((float)p1.getX(),(float) p1.getY());
			   }
			   invalidPath[i].closePath();
		   }

	   }
	   public void constructPlan()
	   {
		   validPath = new GeneralPath[nValidPolygons];

		   int i,j;
		   for(i = 0; i < nValidPolygons; i++)
		   {

			   validPath[i] = new GeneralPath(GeneralPath.WIND_EVEN_ODD);
			   Point2D p = (Point2D) vPoints[i].elementAt(0);
			   Point2D p1;
			   validPath[i].moveTo((float)p.getX(),(float) p.getY());
			   for(j = 1; j < vPoints[i].size(); j++)
			   {
				   p1 = (Point2D) vPoints[i].elementAt(j);
				   validPath[i].lineTo((float)p1.getX(),(float) p1.getY());
			   }
			   validPath[i].closePath();
			   Rectangle r = validPath[i].getBounds();
			   nWidth  = (int)Math.ceil(r.getWidth()/SCALE);
			   nHeight = (int)Math.ceil(r.getHeight()/SCALE);

		   }
	   }

	public boolean isCompletelyInside(Cell_Client c)
	{
		int i ;

		Rectangle2D r = c.getBoundingRectangle();

		boolean validFlag = false;
		boolean invalidFlag = false;

		for(i = 0; i < validPath.length; i++ )
		{
			if(validPath[i].contains(r))
			{
				validFlag = true;
				break;
			}
			else
			{
				validFlag = false;
				break;
			}

		}


		for(i=0;i<invalidPath.length;i++)
		{
			if(invalidPath[i].intersects(r))
			{
				invalidFlag = true;
				break;
			}
		}
		boolean flag = false;
		if(validFlag)
		{
			if(invalidFlag)
				flag = false;
			else
				flag = true;
		}
		return flag;
	}

	public boolean isValidPoint(Point2D p)
	{
		int i;
		boolean validFlag = false;
		for(i=0;i<validPath.length;i++)
		{
			if(validPath[i].contains(p))
			{
				validFlag = true;
				break;
			}
		}
		boolean invalidFlag = false;
		for(i=0;i<invalidPath.length;i++)
		{
			if(invalidPath[i].contains(p))
			{
				invalidFlag = true;
				break;
			}
		}
		boolean flag = false;
		if(validFlag==true)
		{
			if(invalidFlag==true)
			{
				flag = false;
			}
			else
			{
				flag = true;
			}
		}
		return flag;
	}


	private class MouseClickHandler extends MouseAdapter
	{


		public MouseClickHandler()
		{

		}




	    public void mouseClicked(MouseEvent e)
		{

			Point2D.Float p = new Point2D.Float(e.getX(), e.getY());
			if(isValidPoint(p))
			{
				Cell_Client dummy = new Cell_Client(p);
				if(isCompletelyInside(dummy))
				{
					if(defStartLoc==null)
					{
						setCursor ( new Cursor ( Cursor.DEFAULT_CURSOR) ) ;
						defStartLoc = new Cell_Client(p);
						currentLoc = new Cell_Client(p);
						go = new GetOrientation(new JFrame(), true);
						go.show();
						orientation = go.getOrientation();
						orgOrientation = go.getOrientation();
						repaint();
					}
					else
					{

					}
					System.out.println("Clicked!!!");
					statusBar.setText("Clicked at " + dummy.toString());

				}

			}
			else
			{
				statusBar.setText("Clicked at invalid location" );
			}

		}


		public void mouseEntered(MouseEvent e)
		{
			statusBar.setText("Mouse in window..");
		}

		public void mouseExited(MouseEvent e)
		{
			statusBar.setText("Mouse outside the window..");
		}
	}

    public int getOrientation()
    {
		return orientation;
	}

	public int getOrgOrientation()
	{
		return orgOrientation;
	}
    public Cell_Client getStartLoc()
    {
		return defStartLoc;
	}

    public void setStartLoc(Cell_Client x)
    {
		defStartLoc = x;
	}


	private class MouseMotionHandler extends MouseMotionAdapter
	{
		public void mouseMoved(MouseEvent e)
		{
			Point2D.Float p = new Point2D.Float(e.getX(), e.getY());
			if(isValidPoint(p))
			{
				Cell_Client dummy = new Cell_Client(p);
				if(isCompletelyInside(dummy))
				{
					statusBar.setText("Moving over " + dummy.toString());
				}
				else
				{
					statusBar.setText("Moving over " + dummy.toString() + " : Not completely within the wumpus world");
				}

			}
			else
			{
				statusBar.setText("Moving over invalid location" );
			}
		}
	}

 		public void fileRead(String planFile, String obstacleFile)
		{

			try{



			FileReader fr = new FileReader(planFile);
			BufferedReader br = new BufferedReader(fr);
			String s;
			String str1 = new String();
			String str2 = new String();
			String str3 = new String();
			String str4 = new String();
			s = br.readLine();

			nValidPolygons = Integer.parseInt(s);
			vPoints = new Vector[Integer.parseInt(s)];
			int k;
			for(k=0;k<nValidPolygons;k++)
				vPoints[k] = new Vector();

			int i = 0;
			StringTokenizer tok;
			while((s=br.readLine())!=null)
			{
				System.out.println(i + s);
				if(s.equals("*************************"))
				{
					i++;
					continue;
				}

				tok = new StringTokenizer(s,"(',\")");
				str1 = tok.nextToken();
				str2 = tok.nextToken();
				str3 = tok.nextToken();
				str4 = tok.nextToken();
				System.out.println(str1+""+str2+""+str3+""+str4);
				Point2D.Float p = new Point2D.Float((Float.parseFloat(str1)*3)+(Float.parseFloat(str2)/4), (Float.parseFloat(str3)*3)+(Float.parseFloat(str4)/4));
				vPoints[i].add(p);

			}//end outer while

			System.out.println("Obstacles");
			FileReader fr1 = new FileReader(obstacleFile);
			BufferedReader br1 = new BufferedReader(fr1);
			s = br1.readLine();
			nInvalidPolygons = Integer.parseInt(s);
			vObstacles = new Vector[Integer.parseInt(s)];
			for(k=0;k<nInvalidPolygons;k++)
				vObstacles[k] = new Vector();

			i = 0;

			while((s=br1.readLine())!=null)
			{
				System.out.println(s);
				if(s.equals("*************************"))
				{
					i++;
					continue;
				}

				tok = new StringTokenizer(s,"(',\")");
				str1 = tok.nextToken();
				str2 = tok.nextToken();
				str3 = tok.nextToken();
				str4 = tok.nextToken();
				Point2D.Float p = new Point2D.Float(Float.parseFloat(str1)*3+(Float.parseFloat(str2)/4), Float.parseFloat(str3)*3+(Float.parseFloat(str4)/4));
				vObstacles[i].add(p);
			}//end outer while

			fr.close();
		    fr1.close();
			}
			catch(Exception e)
			{
				System.out.println("Error occurred");
			}
	    }

	public void displayCurrentPosition()
	{

	}

	public void setOrientation(int o)
	{
		orientation = o;
	}

	public void setCurrentLocation(Cell_Client cc)
	{

		if(cc!=null)
		{
		System.out.println("Setting current position");
		currentLoc = new Cell_Client(cc.getX()*6, cc.getY()*6);
		System.out.println("current location = " + cc.getX() + ", " + cc.getY());
		}
		else
			currentLoc = null;
		repaint();
	}
	public void paintComponent(Graphics g)
	{
			super.paintComponent(g);
			Graphics2D g2d = (Graphics2D) g;
			mapImage.paintIcon(this, g, 75,75);
			g.setColor(Color.white);
			g.drawString("Legend", 75,175);
			g.setColor(Color.red);
			g.fillRect(75,185,6,3);
			g.drawString(": Starting Location", 85, 188);

			g.setColor(Color.green);
			g.fillRect(75, 200, 6, 3);
			g.drawString(": Current Location", 85, 203);

			BufferedImage buffImage = new BufferedImage(6,6, BufferedImage.TYPE_INT_RGB);
			Graphics2D gg = buffImage.createGraphics();

			gg.setColor(Color.black);
			gg.setColor(Color.white);

			gg.fillRect(0,0,6,6);
		    gg.setColor(Color.black);

		    gg.drawRect(0,0,6,6);

			g2d.setColor(Color.white);
			g2d.setPaint(

				new TexturePaint(buffImage, new Rectangle(6,6))
				);
			int i;
			for(i = 0; i < nValidPolygons ; i++)
			{
				g2d.fill(validPath[i]);
			}

			g2d.setColor(Color.black);
			for(i = 0; i < nInvalidPolygons ; i++)
			{
				g2d.fill(invalidPath[i]);
			}

			if(defStartLoc!=null)
			{
				g2d.setColor(Color.red);
				g2d.fillRect(defStartLoc.getX()*6,defStartLoc.getY()*6,6,3);
			}

			if(currentLoc!=null)
			{
				System.out.println(currentLoc.getX() +", "+ currentLoc.getY());
				g2d.setColor(Color.green);
				g2d.fillRect(currentLoc.getX()*6,currentLoc.getY()*6+3,6,3);
			}
			scrollRectToVisible(new Rectangle(0,0,633,633));
			revalidate();
	}

	void draw()
	{
		repaint();
	}
}