import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;
import java.io.*;
class CustomizedPanel extends JPanel
{
	private JLabel statusBar;
	private Vector logOfAllActions;
	private GeneralPath path;
	private Vector[][] objectsAtCell;
	private Dimension size;
	private Vector[] vPoints;
	private Vector[] vObstacles;
	private int nValidPolygons;
	private int nInvalidPolygons;
	private GeneralPath[] validPath;
	private GeneralPath[] invalidPath;
	private String currentSelection;
	private WWServer wwServer;

	private Vector allWumpii;
	private int nWidth;
	private int nHeight;
	private Environment env;
	private CustomizedPanel() { }
	public CustomizedPanel(Environment e, JLabel s, String planFile, String obstacleFile)
	{
		allWumpii = new Vector();
		statusBar = s;
		setOpaque(true);
		fileRead(planFile, obstacleFile);
		constructPlan();
		constructObstacles();
		size = new Dimension(0,0);


		currentSelection = new String("Default");

		objectsAtCell = new Vector[nHeight][nWidth];
		for(int i = 0 ; i < nHeight; i++)
		{
			for(int j = 0; j < nWidth; j++)
			{
				objectsAtCell[i][j] = new Vector();
			}
		}

		env = e;
		env.setAllWumpii(allWumpii);
		env.setGridImage(objectsAtCell);

		logOfAllActions = new Vector();

		setBackground(Color.black);
		addMouseMotionListener( new MouseMotionHandler());
		addMouseListener(new MouseClickHandler());

	}

   public int getnHeight()
   {
	   return nHeight;
   }

   public int getnWidth()
   {
	   return nWidth;
   }
   public void setEnvironment(Environment e)
   {
	   env = e;
   }

   public Environment getEnvironment()
   {
	   return env;
   }
   public void constructPlan()
   {
	   validPath = new GeneralPath[nValidPolygons];

	   int i,j;
	   for(i = 0; i < nValidPolygons; i++)
	   {

		   validPath[i] = new GeneralPath(GeneralPath.WIND_EVEN_ODD);
		   Point2D p = (Point2D) vPoints[i].elementAt(0);
		   Point2D p1;
		   validPath[i].moveTo((float)p.getX(),(float) p.getY());
		   for(j = 1; j < vPoints[i].size(); j++)
		   {
			   p1 = (Point2D) vPoints[i].elementAt(j);
			   validPath[i].lineTo((float)p1.getX(),(float) p1.getY());
		   }
		   validPath[i].closePath();
		   Rectangle r = validPath[i].getBounds();
		   nWidth  = (int)Math.ceil(r.getWidth()/12);
		   nHeight = (int)Math.ceil(r.getHeight()/12);

	   }
   }

      public void setWWServer(WWServer w)
      {
		  wwServer = w;
	  }
	  public void undoPreviousAction()
	  {
		  System.out.println(Integer.toString(logOfAllActions.size()));
		  if(logOfAllActions.size() > 0)
		  {
			ActionInformation action = (ActionInformation) logOfAllActions.lastElement();
			Cell c = action.getCell();
			logOfAllActions.remove(action);
			objectsAtCell[c.getY()][c.getX()].remove(action.getEntity());
			repaint();
	  	  }
	  }
	  public void setPitCursor()
	  {

		 Image i = Toolkit .getDefaultToolkit() .getImage("c:\\wumpus\\pitIcon.gif");
		 Point p = new Point(0,0);
		 currentSelection = new String("Pit");

		 setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
	  }
	  public void setObstacleCursor()
	  {
		 Image i = Toolkit .getDefaultToolkit() .getImage("c:\\wumpus\\ObstacleIcon.gif");
		 Point p = new Point(0,0);
		  currentSelection = new String("Obstacle");

		 setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
	  }
	  public void setWumpusCursor()
	  {
		 Image i = Toolkit .getDefaultToolkit() .getImage("c:\\wumpus\\wumpusFrontIcon.gif");
		 Point p = new Point(0,0);
		  currentSelection = new String("Wumpus");

		 setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
	  }
	  public void setGoldCursor()
	  {
		 Image i = Toolkit .getDefaultToolkit() .getImage("c:\\wumpus\\pot_o_goldIcon.gif");
		 Point p = new Point(0,0);
		  currentSelection = new String("Gold");

		 setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
  	  }
	  public void setDefaultCursor()
	  {
		   currentSelection = new String("Default");
		   setCursor ( new Cursor ( Cursor.DEFAULT_CURSOR) ) ;
	  }
	   public void constructObstacles()
	   {
		   invalidPath = new GeneralPath[nInvalidPolygons];
		   int i,j;
		   for(i = 0; i < nInvalidPolygons; i++)
		   {

			   invalidPath[i] = new GeneralPath(GeneralPath.WIND_EVEN_ODD);
			   Point2D p = (Point2D) vObstacles[i].elementAt(0);
			   Point2D p1;
			   invalidPath[i].moveTo((float)p.getX(),(float) p.getY());
			   for(j = 1; j < vObstacles[i].size(); j++)
			   {
				   p1 = (Point2D) vObstacles[i].elementAt(j);
				   invalidPath[i].lineTo((float)p1.getX(),(float) p1.getY());
			   }
			   invalidPath[i].closePath();
		   }

	   }

		public void fileRead(String planFile, String obstacleFile)
		{

			try{



			FileReader fr = new FileReader(planFile);
			BufferedReader br = new BufferedReader(fr);
			String s;
			String str1 = new String();
			String str2 = new String();
			String str3 = new String();
			String str4 = new String();
			s = br.readLine();

			nValidPolygons = Integer.parseInt(s);
			vPoints = new Vector[Integer.parseInt(s)];
			int k;
			for(k=0;k<nValidPolygons;k++)
				vPoints[k] = new Vector();

			int i = 0;
			StringTokenizer tok;
			while((s=br.readLine())!=null)
			{
				System.out.println(i + s);
				if(s.equals("*************************"))
				{
					i++;
					continue;
				}

				tok = new StringTokenizer(s,"(',\")");
				str1 = tok.nextToken();
				str2 = tok.nextToken();
				str3 = tok.nextToken();
				str4 = tok.nextToken();
				System.out.println(str1+""+str2+""+str3+""+str4);
				Point2D.Float p = new Point2D.Float(Float.parseFloat(str1)*12+Float.parseFloat(str2), Float.parseFloat(str3)*12+Float.parseFloat(str4));
				vPoints[i].add(p);


			}//end outer while

			System.out.println("Obstacles");
			FileReader fr1 = new FileReader(obstacleFile);
			BufferedReader br1 = new BufferedReader(fr1);
			s = br1.readLine();
			nInvalidPolygons = Integer.parseInt(s);
			vObstacles = new Vector[Integer.parseInt(s)];
			for(k=0;k<nInvalidPolygons;k++)
				vObstacles[k] = new Vector();

			i = 0;

			while((s=br1.readLine())!=null)
			{
				System.out.println(s);
				if(s.equals("*************************"))
				{
					i++;
					continue;
				}

				tok = new StringTokenizer(s,"(',\")");
				str1 = tok.nextToken();
				str2 = tok.nextToken();
				str3 = tok.nextToken();
				str4 = tok.nextToken();
				Point2D.Float p = new Point2D.Float(Float.parseFloat(str1)*12+Float.parseFloat(str2), Float.parseFloat(str3)*12+Float.parseFloat(str4));
				vObstacles[i].add(p);
			}//end outer while

			fr.close();
		    fr1.close();
			}
			catch(Exception e)
			{
				System.out.println("Error occurred");
			}
	    }

	protected synchronized void paintComponent(Graphics g)
	{
		super.paintComponent(g);

	Graphics2D g2d = (Graphics2D) g;
	BufferedImage buffImage = new BufferedImage(12,12, BufferedImage.TYPE_INT_RGB);
	Graphics2D gg = buffImage.createGraphics();

	gg.setColor(Color.black);
	gg.setColor(Color.white);
	gg.fillRect(0,0,12,12);
    gg.setColor(Color.black);
    gg.drawRect(0,0,12,12);

	g2d.setColor(Color.white);
	g2d.setPaint(
		new TexturePaint(buffImage, new Rectangle(12,12))
		);
	int i;
	for(i = 0; i < nValidPolygons ; i++)
	{
		g2d.fill(validPath[i]);
	}

	g2d.setColor(Color.black);
	for(i = 0; i < nInvalidPolygons ; i++)
	{
		g2d.fill(invalidPath[i]);
	}

	for(int p = 0; p < nHeight; p++)
	{
		for(int q = 0; q < nWidth; q++)
		{
			for(int l = 0; l < objectsAtCell[p][q].size(); l++)
			{
				Object o = objectsAtCell[p][q].elementAt(l);
				if (o instanceof Pit)
				{
					g2d.setColor(Color.red);
					g2d.fillRect(q*12, p*12, 6,6);
				}
				else
				{
					 if(o instanceof Obstacle)
					 {
					 	g2d.setColor(Color.blue);
					 	g2d.fillRect((q*12)+6, (p*12), 6,6);
					 }
					 else
					 {
					  if(o instanceof Wumpus)
					  {
					 	g2d.setColor(Color.green);
					 	g2d.fillRect((q*12), (p*12)+6, 6,6);
					  }
					  else
					  {
					 	g2d.setColor(Color.lightGray);
					 	g2d.fillRect((q*12)+6, (p*12)+6, 6,6);
					  }
					}
			   }
			}
		}
	}


	scrollRectToVisible(new Rectangle(0,0,2532,2532));
	revalidate();
	}
	public void draw()
	{
		repaint();
	}
	public boolean isValidPoint(Point2D p)
	{
		int i;
		boolean validFlag = false;
		for(i=0;i<validPath.length;i++)
		{
			if(validPath[i].contains(p))
			{
				validFlag = true;
				break;
			}
		}
		boolean invalidFlag = false;
		for(i=0;i<invalidPath.length;i++)
		{
			if(invalidPath[i].contains(p))
			{
				invalidFlag = true;
				break;
			}
		}
		boolean flag = false;
		if(validFlag==true)
		{
			if(invalidFlag==true)
			{
				flag = false;
			}
			else
			{
				flag = true;
			}
		}
		return flag;
	}

	public void readWorld(String s)
	{

		try
		{
		  FileInputStream fin =  new FileInputStream(s);

		  // now turn the FileInputStream into a DataInputStream
		  try
		  {
			java.io.DataInputStream myInput = new java.io.DataInputStream(fin);
			String thisLine=null;
   			StringTokenizer tokenizer;
			try
			{
			  thisLine = myInput.readLine();
			  if(thisLine==null)
			  	return;
			  else
			  {
				tokenizer = new StringTokenizer(thisLine, "[,] ");
				nHeight = Integer.parseInt(tokenizer.nextToken());
				nWidth  = Integer.parseInt(tokenizer.nextToken());
				System.out.println(Integer.toString(nHeight)+ "," + Integer.toString(nWidth));

				logOfAllActions = new Vector();
				objectsAtCell = new Vector[nHeight][nWidth];
				for(int i = 0; i < nHeight; i++)
				{
					for(int j = 0; j < nWidth; j++)
					{
						objectsAtCell[i][j] = new Vector();
					}
				}
			  }

			   /* Reset the vector for all wumpii */
			   allWumpii = new Vector();

			   /* Sets the grid image and all wumpii vector in environment */
			   env.setGridImage(objectsAtCell);
			   env.setAllWumpii(allWumpii);

			  while ((thisLine = myInput.readLine()) != null)
			   {
				System.out.println("Line : " + thisLine);
				tokenizer = new StringTokenizer(thisLine, "Cell [,]:");
				/*while(tokenizer.hasMoreTokens())
				{
					System.out.println(tokenizer.nextToken());
				}*/

				int x = Integer.parseInt(tokenizer.nextToken());
				int y = Integer.parseInt(tokenizer.nextToken());
				System.out.println(Integer.toString(x)+ "," + Integer.toString(y));
				String entity = tokenizer.nextToken();
				System.out.println("Entity  is " + entity);

				if(entity.equals("Pit"))
				{
					Pit  pit = new Pit();
					logOfAllActions.add(new ActionInformation(new Cell(x*12,y*12), pit ));
					objectsAtCell[y][x].add(pit);
				}
				else
				if(entity.equals("Obstac"))
				{
					Obstacle obstacle = new Obstacle();
					logOfAllActions.add(new ActionInformation(new Cell(x*12,y*12), obstacle));
					objectsAtCell[y][x].add(obstacle);
				}
				else
				if(entity.equals("Gold"))
				{
					Gold gold = new Gold();
					logOfAllActions.add(new ActionInformation(new Cell(x*12,y*12), gold));
					objectsAtCell[y][x].add(gold);

				}
				else
				{
					Wumpus wumpus = new Wumpus(1, x, y, 3, 0, "Wumpus", wwServer.getSelWumpusMode() );
					logOfAllActions.add(new ActionInformation(new Cell(x*12,y*12), wumpus));
					objectsAtCell[y][x].add(wumpus);
					allWumpii.add(wumpus);
				}

			   } // while loop ends here

			}
			catch (Exception x1)
			{
			 System.err.println("Error: " + x1);
			}
		  } // end try
		  catch (Exception x2)
		  {
			System.err.println("Error: " + x2);
		  }

		 } // end try
		 catch (Exception x3)
		 {
		  System.err.println("failed to open file output");
		  System.err.println("Error: " + x3);
		 }

 	repaint();
 	}
	public void writeWorld(String s)
	{
		try
		{
			FileWriter fw = new FileWriter(s);
			fw.write("[ " + Integer.toString(nHeight) + "," + Integer.toString(nWidth) + " ]" + '\n');
			for(int i = 0; i < nHeight; i++)
			{
				for(int j = 0; j < nWidth; j++)
				{

					for(int l=0;l<objectsAtCell[i][j].size();l++)
					{
						Object o = objectsAtCell[i][j].elementAt(l);
						if (o instanceof Pit)
						{
						   fw.write("Cell[" + j + "," + i + "] : Pit " + '\n');
						}
						else
						{
							 if(o instanceof Obstacle)
							 {
					 			fw.write("Cell[" + j + "," + i + "] : Obstac " + '\n');
							 }
							 else
							 {
							  if(o instanceof Wumpus)
							  {
					  			fw.write("Cell[" + j + "," + i + "] : Wumpus " + '\n');
							  }
							  else
							  {
					  			fw.write("Cell[" + j + "," + i + "] : Gold " + '\n');
							  }
							}
					   }

					}
				}
			}
			fw.close();
		}
		catch(java.io.IOException e)
		{
			JOptionPane.showMessageDialog(null, "Exception while writing to file");
		}

	}

	public boolean isCompletelyInside(Cell c)
	{
		int i ;

		Rectangle2D r = c.getBoundingRectangle();

		boolean validFlag = false;
		boolean invalidFlag = false;

		for(i = 0; i < validPath.length; i++ )
		{
			if(validPath[i].contains(r))
			{
				validFlag = true;
				break;
			}
			else
			{
				validFlag = false;
				break;
			}

		}


		for(i=0;i<invalidPath.length;i++)
		{
			if(invalidPath[i].intersects(r))
			{
				invalidFlag = true;
				break;
			}
		}
		boolean flag = false;
		if(validFlag)
		{
			if(invalidFlag)
				flag = false;
			else
				flag = true;
		}
		return flag;
	}

	private void displayErrorMsg(String s)
	{


		MessageDialog x = new MessageDialog(new JFrame(s), true, "Cannot put pit here. There is either an obstacle or another pit already");
		x.show();

	}



	private class MouseClickHandler extends MouseAdapter
	{


		public MouseClickHandler()
		{

		}
		public void mouseReleased(MouseEvent e)
		{
			if(e.getClickCount()>1)
			{
				Point2D.Float p = new Point2D.Float(e.getX(), e.getY());
				if(isValidPoint(p))
				{
					Cell dummy = new Cell(p);
					if(isCompletelyInside(dummy))
					{
						GridInfoDialog gid = new GridInfoDialog(new JFrame(), true,dummy, objectsAtCell[dummy.getY()][dummy.getX()] );
						gid.show();
					}
				}
			}
		}



	    public void mouseClicked(MouseEvent e)
		{
			Point2D.Float p = new Point2D.Float(e.getX(), e.getY());
			if(isValidPoint(p))
			{
				Cell dummy = new Cell(p);
				if(isCompletelyInside(dummy))
				{
					statusBar.setText("Clicked at " + dummy.toString());
					if(currentSelection.equals("Pit"))
					{
						/*
						Add Pit at the cell if and only if
						 there is no pit and no obstacle
						*/
						if(!env.isObstacleAt(dummy.getX(), dummy.getY()) && !env.isPitAt(dummy.getX(), dummy.getY()))
						{
							Pit  pit = new Pit();
							logOfAllActions.add(new ActionInformation(dummy, pit ));
							objectsAtCell[dummy.getY()][dummy.getX()].add(pit);
							repaint();
						}
						else
						{

							MessageDialog x = new MessageDialog(new JFrame(), true, "Cannot put pit here. There is either an obstacle or another pit already in this cell");
							//x.setSize(450,100);
							x.show();
						}
					}
					else
					 if(currentSelection.equals("Obstacle"))
					 {
						 if(!env.isPitAt(dummy.getX(), dummy.getY())&&!env.isObstacleAt(dummy.getX(), dummy.getY())&&!env.isWumpusAt(dummy.getX(), dummy.getY())&&!env.isGoldAt(dummy.getX(), dummy.getY()))
						 {
							Obstacle obstacle = new Obstacle();
							logOfAllActions.add(new ActionInformation(dummy, obstacle));
						 	objectsAtCell[dummy.getY()][dummy.getX()].add(obstacle);
						 	repaint();
					 	 }
					 	 else
					 	 {
							MessageDialog x = new MessageDialog(new JFrame(), true, "Cannot put obstacle here. There is either an obstacle, a pit, some gold or a wumpus already in this cell");
							//x.setSize(600,100);
							x.show();
						 }
					 }
					 else
					  if(currentSelection.equals("Gold"))
					  {
						  if(!env.isObstacleAt(dummy.getX(), dummy.getY())&&!env.isGoldAt(dummy.getX(), dummy.getY()))
						  {
							  Gold gold = new Gold();
							  logOfAllActions.add(new ActionInformation(dummy, gold));
							  env.addGoldAt(new GridPoint(dummy.getX(), dummy.getY()));
						  	  objectsAtCell[dummy.getY()][dummy.getX()].add(gold);
						  	  repaint();
					  	  }
					  	  else
					  	  {
							MessageDialog x = new MessageDialog(new JFrame(), true, "Cannot put gold here. There is either an obstacle or some gold already in this cell");
							//x.setSize(450,100);
							x.show();
						  }
					  }
					  else
					   if(currentSelection.equals("Wumpus"))
					    {
							if(!env.isObstacleAt(dummy.getX(), dummy.getY())&&!env.isWumpusAt(dummy.getX(), dummy.getY()))
							{




							    wwServer.getWumpusMode();


							   Wumpus wumpus = new Wumpus(1,dummy.getX(), dummy.getY(), 3, 0, "Wumpus", wwServer.getSelWumpusMode() );




							  logOfAllActions.add(new ActionInformation(dummy, wumpus));
							  objectsAtCell[dummy.getY()][dummy.getX()].add(wumpus);
							  allWumpii.add(wumpus);
							  repaint();
							}
							else
							{
							MessageDialog x = new MessageDialog(new JFrame(), true, "Cannot put wumpus here. There is either an obstacle or a wumpus already in this cell");
							x.show();

							}
					    }
				}
				else
				{
					statusBar.setText("Clicked at " + dummy.toString() + " : Not completely within the wumpus world");
				}

			}
			else
			{
				statusBar.setText("Clicked at invalid location" );
			}

		}

		public void mouseEntered(MouseEvent e)
		{
			statusBar.setText("Mouse in window..");
		}

		public void mouseExited(MouseEvent e)
		{
			statusBar.setText("Mouse outside the window..");
		}
	}

	private class MouseMotionHandler extends MouseMotionAdapter
	{
		public void mouseMoved(MouseEvent e)
		{
			Point2D.Float p = new Point2D.Float(e.getX(), e.getY());
			if(isValidPoint(p))
			{
				Cell dummy = new Cell(p);
				if(isCompletelyInside(dummy))
				{
					statusBar.setText("Moving over " + dummy.toString());
				}
				else
				{
					statusBar.setText("Moving over " + dummy.toString() + " : Not completely within the wumpus world");
				}

			}
			else
			{
				statusBar.setText("Moving over invalid location" );
			}
		}
	}


}

class MessageDialog extends JDialog
{
	JPanel center, panel;
	private MessageDialog() { }
	public MessageDialog(JFrame frame, boolean doModal, String s)
	{
		super(frame, doModal);
		getContentPane().setLayout(new BorderLayout());

		JTextField jTF = new JTextField(s);

		jTF.setEditable(false);
		getContentPane().add(jTF);
		setSize(600,70);
	}

}
class GridInfoDialog extends JDialog
{
	private GridInfoDialog() { }
	public GridInfoDialog(JFrame frame, boolean doModal, Cell c, Vector v)
	{

		super(frame, doModal);
		JTextArea jTextArea = new JTextArea();
		jTextArea.setEditable(false);
		getContentPane().setLayout(new BorderLayout());

		getContentPane().add(new JScrollPane(jTextArea),BorderLayout.CENTER);

		JTextField jTextField = new JTextField("Content of " + c);
		jTextField.setEditable(false);
		getContentPane().add(jTextField, BorderLayout.NORTH);


		for(int i = 0; i < v.size();i++)
		{
			Object o = v.elementAt(i);
			if (o instanceof Pit)
			{
			   jTextArea.append("Contains Pit\n");
			}
			else
			{
				 if(o instanceof Obstacle)
				 {
					jTextArea.append("Has An Obstacle\n");
				 }
				 else
				 {
				  if(o instanceof Wumpus)
				  {
					jTextArea.append("Careful...has a wumpus\n");
					Wumpus w = (Wumpus) v.elementAt(i);
					int orientation = w.getOrientation();
					switch(orientation)
					{
						case 2:
							jTextArea.append("Wumpus is facing EAST");
							break;
						case 1:
							jTextArea.append("Wumpus is facing NORTH");
							break;
						case 4:
							jTextArea.append("Wumpus is facing WEST");
							break;
						case 3:
							jTextArea.append("Wumpus is facing SOUTH");
							break;
					}
					jTextArea.append(" and its mode is " + WumpusMode.toString(w.getMode()) + "\n");
				  }
				  else
				  {
					if(o instanceof Gold)
						jTextArea.append("Wow!! There is gold!\n");
				  }
				}
		   }

		}
		setSize(300,300);
	}
}