//package wworld;

/**
    This class is used to describe the directions in which the moving
    objects in the World can face.
    @author Kruti Mehta
*/
public class Directions
{
   public static final int NORTH = 1;
   public static final int EAST = 2;
   public static final int SOUTH = 3;
   public static final int WEST = 4;

   private int facing;

   /**
   Constructor for the facing or directions
   @param Direction that the moving object is initially facing.
   */
   public Directions(int lookingTo)
   {
    facing = lookingTo;
   }

   /**
   Returns the direction that is represented by the object.
   @return object facing or direction as integer.
   */
   public int getFacing()
   {
    return facing;
   }

   /**
   Used to set the facing represented by this object.
   @param facing of the object as integer.
   */
   public void setFacing(int i)
   {
    facing = i;
   }

   /**
   Returns the direction or facing of the object as String.
   @return facing of the object - left, right, up or down as String.
   */
   public String toString()
   {
    String s = new String();
    if(facing == NORTH) s = "NORTH";
    else if(facing ==EAST) s = "EAST";
    else if(facing ==SOUTH) s = "SOUTH";
    else if(facing ==WEST) s = "WEST";

    return s;
   }

}
