
//Title:        wclient
//Version:
//Copyright:    Copyright (c) 1999
//Author:       Kruti Mehta
//Company:      UTA
//Description:  Research Assistant

//package wclient;

import java.awt.*;
import javax.swing.JFrame;
import java.io.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.JFrame;
import java.util.*;
import java.awt.image.*;
import java.net.*;

//import wAction.Action;
//import wPercept.TransferPercept;

/**
Frame Displaying the normal percepts and the natural language hint.
*/

public class Frame1 extends JFrame
{
   MenuBar mbar;
   CheckboxMenuItem displayImage;
   CheckboxMenuItem displayPercept;
   CheckboxMenuItem displayHint;
   CheckboxMenuItem displayStatus;

   TextField stenchText = new TextField();
   TextField breezeText = new TextField();
   TextField glitterText = new TextField();
   TextField bumpText = new TextField();
   TextField screamText = new TextField();
   TextField hintText = new TextField();
   TextField lastActionText = new TextField();
   TextField agentStatusText = new TextField();
   TextField scoreText = new TextField();
   TextField arrowText = new TextField();
   TextField goldPiecesText = new TextField();
   JTextArea jCommandStatus = new JTextArea(8,55);

   TextField noofTrialsText = new TextField();
   TextField currentTrialText = new TextField();
   TextField maxStepsText = new TextField();
   TextField currentStepText = new TextField();


   Panel panel0 = new Panel();
   Panel panel1 = new Panel();
   Panel panel2 = new Panel();
   Panel panel3 = new Panel();
   int action;

   int maxSteps;
   int noofTrials;

   int currentStep;
   int currentTrial;

   ObjectOutputStream output;
   ObjectInputStream  input;
   public Frame1()
   {
	setTitle("Percepts received from wumpus world");
    setArea();
    this.getContentPane().setSize(200,400);

   }

   public void setOutputSocket(ObjectOutputStream o)
   {
	   output = o;
   }
   public void setInputSocket(ObjectInputStream i)
   {
	   input = i;
   }

   // This member function is called to basically set the GUI components of
   // the percept frame while waiting for other agents to finish their trial

   public void setGUIComponents()
   {
		/*
			We have to disable the following gui items
			1. Action button disabled
			2. Add in the percept frame that we are waiting for the next trial
			3. score updated
		*/
		stenchText.setText("");
		breezeText.setText("");
		glitterText.setText("");
		bumpText.setText("");
		screamText.setText("");
		hintText.setText("");
		lastActionText.setText("");
		agentStatusText.setText("");
		scoreText.setText("0");
		arrowText.setText("");
		goldPiecesText.setText("");
		//noofTrialsText.setText("");
		currentTrialText.setText("");
		//maxStepsText.setText("");
		currentStepText.setText("");
		btnAction.setEnabled(false);
   }

   public void setArea()
   {

	this.getContentPane().setLayout(new BorderLayout());
	JPanel topPanel = new JPanel();
	topPanel.setLayout(new GridBagLayout());
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.fill = GridBagConstraints.BOTH;
    gbc.gridx = 1;
    gbc.gridy = 1;
    gbc.gridwidth = 1;
    gbc.gridheight = 1;
    gbc.weightx = 1;
    gbc.weighty = 0.45;
    setPerceptPanel();
    topPanel.add(panel0,gbc);
    gbc.gridy = 2;
    gbc.weighty = 0.1;
    setHintPanel();
    topPanel.add(panel1,gbc);
    gbc.gridy = 3;
    gbc.weighty = 0.45;
    setStatusPanel();
    topPanel.add(panel2,gbc);
    gbc.gridy = 4;
    setActionPanel();
    topPanel.add(panel3, gbc);

 	JPanel bottomPanel = new JPanel();
 	bottomPanel.setLayout(new BorderLayout());

    JPanel bTPanel = new JPanel();
    bTPanel.setLayout(new GridLayout(2,4));
    bTPanel.add(new JLabel("Max Steps Per Trial :", JLabel.RIGHT));
    bTPanel.add(maxStepsText);
    bTPanel.add(new JLabel("Number Of Trials : ", JLabel.RIGHT));
    bTPanel.add(noofTrialsText);

    bTPanel.add(new JLabel("Current Step : ", JLabel.RIGHT));
    bTPanel.add(currentStepText);
    bTPanel.add(new JLabel("Current Trial : ", JLabel.RIGHT));
    bTPanel.add(currentTrialText);


 	jCommandStatus.setEditable(false);
 	bottomPanel.add(bTPanel, BorderLayout.NORTH);
	bottomPanel.add(new JScrollPane(jCommandStatus), BorderLayout.SOUTH);

	this.getContentPane().add(topPanel,BorderLayout.NORTH);
	this.getContentPane().add(bottomPanel,BorderLayout.SOUTH);
   }


   private JRadioButton rb_mvFwd;
   private JRadioButton rb_mvBack;
   private JRadioButton rb_mvLeft;
   private JRadioButton rb_mvRight;
   private JRadioButton rb_stay;
   private JRadioButton rb_shootArrow;
   private JRadioButton rb_grab;
   private JRadioButton rb_climb;
   private JButton btnAction;
   public void setActionPanel()
   {
	   panel3.setLayout(new GridLayout(2,1));
	   panel3.add(new JButton("Action To Be Taken"));
	   rb_mvFwd = new JRadioButton("Forward");

	   rb_mvLeft = new JRadioButton("Left");
	   rb_mvRight = new JRadioButton("Right");
	   rb_stay = new JRadioButton("Stay");
	   rb_shootArrow = new JRadioButton("Shoot Arrow");

	   rb_grab = new JRadioButton("Grab");
	   rb_climb = new JRadioButton("Climb");


	   rb_stay.setSelected(true);
	   action = Action.SIT;
	   btnAction = new JButton("Action");
	   JPanel p = new JPanel();

	   ButtonGroup bg = new ButtonGroup();
	   bg.add(rb_mvFwd);

	   bg.add(rb_mvLeft);
	   bg.add(rb_mvRight);
	   bg.add(rb_stay);
	   bg.add(rb_shootArrow);
	   bg.add(rb_grab);
	   bg.add(rb_climb);
	   p.setLayout(new FlowLayout());
	   p.add(rb_mvFwd);

	   p.add(rb_mvLeft);
	   p.add(rb_mvRight);
	   p.add(rb_stay);
	   p.add(rb_shootArrow);

	   p.add(rb_grab);
	   p.add(rb_climb);
	   p.add(btnAction);
	   btnAction.addActionListener(new Handler());
	   panel3.add(p);

   }

   public JButton getActionButton()
   {
	   return btnAction;
   }
   private class Handler implements ActionListener
   {
	   public void actionPerformed(ActionEvent e)
	   {
		    btnAction.setEnabled(false);
		    jCommandStatus.append("\nAttempted to : ");
			if (rb_mvFwd.isSelected())
			{
			 action = Action.GOFORWARD;
			 jCommandStatus.append("GO FORWARD...");
		 	}
			if(rb_mvLeft.isSelected())
			{
			 action = Action.TURN_LEFT;
			 jCommandStatus.append("TURN LEFT...");
		 	}
			if(rb_mvRight.isSelected())
			{
			 action = Action.TURN_RIGHT;
			 jCommandStatus.append("TURN RIGHT...");
		    }
			if(rb_stay.isSelected())
			{
			 action = Action.SIT;
			 jCommandStatus.append("SIT...");
		 	}
			if(rb_shootArrow.isSelected())
			{
			 action = Action.SHOOT;
			 jCommandStatus.append("SHOOT A WUMPUS...");
		 	}
			if(rb_climb.isSelected())
			{
			 action = Action.CLIMB;
			 jCommandStatus.append("CLIMB OUT OF WUMPUS WORLD...");
		    }
			if(rb_grab.isSelected())
			{
			 action = Action.GRAB;
			 jCommandStatus.append("GRAB GOLD...");
			}
			try
			{
				Integer i = new Integer(action);
				output.writeObject(i.toString());
				output.flush();


			}

			catch(IOException ioe)
			{
				JOptionPane.showMessageDialog(null,"Error : Cannot send the action to the server. Please disconnect");

			}
	   }
   }


   public void  setSW_Agent(boolean s)
   {
	   panel3.setVisible(s);
   }
   public void setPerceptPanel()
   {
    panel0.setLayout(new GridBagLayout());
    GridBagConstraints gbc0 = new GridBagConstraints();
    gbc0.fill = GridBagConstraints.BOTH;
    gbc0.insets = new Insets(10,0,10,0);
    gbc0.gridwidth = 4;
    gbc0.gridheight = 1;
    gbc0.gridx = 1;
    gbc0.gridy = 1;
    gbc0.weightx = 1;
    gbc0.weighty = 0.05;
    JButton jb0 = new JButton();
    jb0.setText("PERCEPT INFORMATION");
    jb0.disable();
    panel0.add(jb0, gbc0);

    gbc0.insets = new Insets(5,5,5,15);
    gbc0.gridwidth = 1;
    gbc0.gridheight = 1;
    gbc0.gridx = 1;
    gbc0.gridy = 2;
    gbc0.weighty = 0.1;
    gbc0.weightx = 0.2;

    panel0.add(new Label("Stench: ",Label.RIGHT),gbc0);
    gbc0.gridx = 2;
    gbc0.gridy = 2;
    gbc0.weightx = 0.3;
    panel0.add(stenchText,gbc0);
    gbc0.gridx = 3;
    gbc0.gridy = 2;
    gbc0.weightx = 0.2;
    panel0.add(new Label("Breeze: ",Label.RIGHT),gbc0);
    gbc0.gridx = 4;
    gbc0.gridy = 2;
    gbc0.weightx = 0.3;
    panel0.add(breezeText,gbc0);
    gbc0.gridx = 1;
    gbc0.gridy = 3;
    gbc0.weightx = 0.2;
    panel0.add(new Label("Glitter: ",Label.RIGHT),gbc0);
    gbc0.gridx = 2;
    gbc0.gridy = 3;
    gbc0.weightx = 0.3;
    panel0.add(glitterText,gbc0);
    gbc0.gridx = 3;
    gbc0.gridy = 3;
    gbc0.weightx = 0.2;
    panel0.add(new Label("Bump: ",Label.RIGHT),gbc0);
    gbc0.gridx = 4;
    gbc0.gridy = 3;
    gbc0.weightx = 0.3;
    panel0.add(bumpText,gbc0);
    gbc0.gridx = 1;
    gbc0.gridy = 4;
    gbc0.weightx = 0.2;
    panel0.add(new Label("Scream: ",Label.RIGHT),gbc0);
    gbc0.gridx = 2;
    gbc0.gridy = 4;
    gbc0.weightx = 0.3;
    panel0.add(screamText,gbc0);
   }

   public void setHintPanel()
   {

    panel1.setLayout(new GridBagLayout());
    GridBagConstraints gbc1 = new GridBagConstraints();
    gbc1.fill = GridBagConstraints.BOTH;
    gbc1.insets = new Insets(10,0,10,0);
    gbc1.gridx = 1;
    gbc1.gridy = 1;
    gbc1.gridheight = 1;
    gbc1.gridwidth = 2;
    gbc1.weightx = 1.0;
    gbc1.weighty = 0.08;
    panel1.add(new JButton("NATURAL LANGUAGE HINT"),gbc1);
    gbc1.insets = new Insets(5,5,5,15);
    gbc1.gridheight = 1;
    gbc1.gridwidth = 1;
    gbc1.gridx = 1;
    gbc1.gridy = 2;
    gbc1.weighty = 0.95;
    gbc1.weightx = 0.01;
    panel1.add(new Label("Hint: ",Label.RIGHT),gbc1);
    gbc1.gridx = 2;
    gbc1.gridy = 2;
    gbc1.weightx = 0.99;
    panel1.add(hintText,gbc1);
   }

   public void setStatusPanel()
   {

    panel2.setLayout(new GridBagLayout());
    GridBagConstraints gbc2 = new GridBagConstraints();
    gbc2.fill = GridBagConstraints.BOTH;
    gbc2.gridx = 1;
    gbc2.gridy = 1;
    gbc2.gridheight = 1;
    gbc2.gridwidth = 4;
    gbc2.weightx = 1.0;
    gbc2.weighty = 0.05;
    gbc2.insets = new Insets(10,0,10,0);
    panel2.add(new JButton("STATUS INFORMATION"),gbc2);

    gbc2.insets = new Insets(5,5,5,15);
    gbc2.gridheight = 1;
    gbc2.gridwidth = 1;


    gbc2.gridx = 1;
    gbc2.gridy = 2;

    gbc2.weighty = 0.1;
    gbc2.weightx = 0.2;

    panel2.add(new Label("Last Action: ",Label.RIGHT),gbc2);
    gbc2.gridx = 2;
    gbc2.gridy = 2;
    gbc2.weightx = 0.3;
    panel2.add(lastActionText,gbc2);
    gbc2.gridx = 3;
    gbc2.gridy = 2;
    gbc2.weightx = 0.2;
    panel2.add(new Label("Agent State: ",Label.RIGHT),gbc2);
    gbc2.gridx = 4;
    gbc2.gridy = 2;
    gbc2.weightx = 0.3;
    panel2.add(agentStatusText,gbc2);
    gbc2.gridx = 1;
    gbc2.gridy = 3;
    gbc2.weightx = 0.2;
    panel2.add(new Label("Score: ",Label.RIGHT),gbc2);
    gbc2.gridx = 2;
    gbc2.gridy = 3;
    gbc2.weightx = 0.3;
    panel2.add(scoreText,gbc2);
    gbc2.gridx = 3;
    gbc2.gridy = 3;
    gbc2.weightx = 0.2;
    panel2.add(new Label("Arrows: ",Label.RIGHT),gbc2);
    gbc2.gridx = 4;
    gbc2.gridy = 3;
    gbc2.weightx = 0.3;
    panel2.add(arrowText,gbc2);
    gbc2.gridx = 1;
    gbc2.gridy = 4;
    gbc2.weightx = 0.2;
    panel2.add(new Label("Gold Pieces: ",Label.RIGHT),gbc2);
    gbc2.gridx = 2;
    gbc2.gridy = 4;
    gbc2.weightx = 0.3;
    panel2.add(goldPiecesText,gbc2);
   }

   public void setMenu()
   {
    MenuBar mbar = new MenuBar();
    Menu displayMenu = new Menu("Display", true);

    displayMenu.add(displayImage = new CheckboxMenuItem("Image"));
    displayMenu.add(displayPercept = new CheckboxMenuItem("Percepts"));
    displayMenu.add(displayHint = new CheckboxMenuItem("Hint"));
    displayMenu.add(displayStatus = new CheckboxMenuItem("Status"));

    displayImage.addItemListener(new ItemListener(){
     public void itemStateChanged(ItemEvent event)
     {
      System.out.println("Image status is " + displayImage.getState());
     }
    });
    displayPercept.addItemListener(new ItemListener(){
     public void itemStateChanged(ItemEvent event)
     {
      System.out.println("Percepts status is " + displayPercept.getState());
     }
    });
    displayHint.addItemListener(new ItemListener(){
     public void itemStateChanged(ItemEvent event)
     {
      System.out.println("Hint status is " + displayHint.getState());
     }
    });
    displayStatus.addItemListener(new ItemListener(){
     public void itemStateChanged(ItemEvent event)
     {
      System.out.println("Status status is " + displayStatus.getState());
     }
    });

    mbar.add(displayMenu);
    setMenuBar(mbar);

   }

   public void setStenchText(String s)
   {
    stenchText.setText(s);
   }

   public void setBreezeText(String s)
   {
    breezeText.setText(s);
   }

   public void setGlitterText(String s)
   {
    glitterText.setText(s);
   }

   public void setBumpText(String s)
   {
    bumpText.setText(s);
   }

   public void setScreamText(String s)
   {
    screamText.setText(s);
   }

   public void setHintText(String s)
   {
    hintText.setText(s);
   }

   public void setLastActionText(String s)
   {
    lastActionText.setText(s);
   }

   public void setAgentStatusText(String s)
   {
    agentStatusText.setText(s);
   }

   public void setScoreText(String s)
   {
    scoreText.setText(s);
   }

   public String getScore()
   {
	   return scoreText.getText();
   }
   public void setArrowText(String s)
   {
    arrowText.setText(s);
   }

   public void setGoldPiecesText(String s)
   {
    goldPiecesText.setText(s);
   }

   public void setMaxStepsText(String s)
   {
	   maxStepsText.setText(s);
   }

   public void setCurrentStepText(String s)
   {
	   currentStepText.setText(s);
   }

   public void setNoofTrialsText(String s)
   {
	   noofTrialsText.setText(s);

   }
   public void setCurrentTrialText(String s)
   {
	   currentTrialText.setText(s);
   }

   public int getAction()
   {
	   return action;
   }

	public JTextArea getCommandStatus()
	{
		return jCommandStatus;
	}
}
