import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

public class G_Client extends JFrame
{

	private JMenuBar  bar;
	private JMenu     planMenu;
	private JMenuItem planMnuItem;
	private JMenuItem exitMnuItem;

	private JMenu     perceptMenu;
	private JMenuItem perceptMenuItem;

	private String    wwServerIP = "129.107.12.9";
	private String    portNumber = "5000";


	private JRadioButton rb_Od;
	private JRadioButton rb_Rr;

	private JTextField   rateTF;

	private String   client;
	private String   wwAgent;

	private ClientDisplay cd;

	private JTextField tf_wwServerIP;
	private JTextField tf_wwServerPort;
	private JButton    btn_Connect;

	private JRadioButton rb_Human;
	private JRadioButton rb_swAgent;
	private JRadioButton rb_Robot;

	private JRadioButton rb_HumanClient;
	private JRadioButton rb_swClient;

	private Frame1 perceptFrame;
	private Frame2 f = null;
	private ObjectInputStream input;
	private ObjectOutputStream output;

	private ClientThread cThread;
	private int id;
	private  ThreadControl tc;
	private   Frame fstop;
	private   OnDemandDlg od;

	private  boolean fcfs;
	public G_Client()
	{
		super("Agent");
		Container c = getContentPane();

		bar = new JMenuBar();
		planMenu = new JMenu();
		planMenu.setText("Plan");
		planMnuItem = new JMenuItem();
		planMenu.add(planMnuItem);
		planMnuItem.setText("Display Layout");
		cd = null;

		exitMnuItem = new JMenuItem();
		exitMnuItem.setText("Exit");

		exitMnuItem.addActionListener(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					System.exit(0);
				}
			}
			);

		planMenu.add(exitMnuItem);
		c.setLayout(new BorderLayout());
		setJMenuBar(bar);
		bar.add(planMenu);

		perceptMenu = new JMenu();
		perceptMenu.setText("Percept");
		perceptMenuItem = new JMenuItem("Display Percepts");
		perceptMenu.add(perceptMenuItem);
		bar.add(perceptMenu);


		addWindowListener(
			new WindowAdapter()
			{
				public void windowClosing(WindowEvent e)
				{
					System.exit(0);
				}
			}
			);
		ActionHandler handler = new ActionHandler();
		planMnuItem.addActionListener(handler);
		getContentPane().setLayout(null);
		JLabel label1 = new JLabel("Wumpus World Server IP: ", JLabel.RIGHT);
		label1.setBounds(25,25,150,20);
		getContentPane().add(label1);
		JLabel label2 = new JLabel("Port #: ", JLabel.RIGHT);
		label2.setBounds(25,55,150,20);
		getContentPane().add(label2);

		tf_wwServerIP = new JTextField();
		tf_wwServerIP.setText(wwServerIP);
		tf_wwServerIP.setBounds(180,25, 100,20);
		getContentPane().add(tf_wwServerIP);
		tf_wwServerPort = new JTextField();
		tf_wwServerPort.setText(portNumber);
		tf_wwServerPort.setBounds(180,55,100,20);
		getContentPane().add(tf_wwServerPort);

		btn_Connect = new JButton("Connect");
		btn_Connect.setBounds(200,255,90,25);
		getContentPane().add(btn_Connect);

		btn_Connect.addActionListener(handler);

		perceptMenuItem.addActionListener(handler);
		JLabel label3 = new JLabel("Avataar in wumpus world...");
		label3.setBounds(25,95, 175, 20);
		getContentPane().add(label3);
		JPanel panel = new JPanel();
		//panel.setBackground(Color.white);
		panel.setBounds(25, 115, 255, 30);
		getContentPane().add(panel);


		ButtonGroup bg = new ButtonGroup();
		rb_Human = new JRadioButton("Human");
		rb_swAgent = new JRadioButton("S/W Avatar");
		rb_Robot = new JRadioButton("Robot");

		bg.add(rb_Human);
		bg.add(rb_swAgent);
		bg.add(rb_Robot);

		rb_Human.setSelected(true);

		rb_Human.setBounds(5,5,75,20);
		rb_Robot.setBounds(85,5,75,20);
		rb_swAgent.setBounds(160,5,90,20);
		final JLabel label = new JLabel("Rate in Secs");

		rb_swAgent.addItemListener(
			new ItemListener()
			{
				public void itemStateChanged(ItemEvent e)
				{
					if(rb_swAgent.isSelected())
					{
						rb_Od.setVisible(false);
						rb_Rr.setVisible(false);
						label.setVisible(false);
						rateTF.setVisible(false);
					}
					else
					{
						rb_Od.setVisible(true);
						rb_Rr.setVisible(true);
						label.setVisible(true);
						rateTF.setVisible(true);

					}
				}
			}
			);
		JLabel lb1 = new JLabel("Obtain Image....");
		lb1.setBounds(25,155,100,20);
		getContentPane().add(lb1);

		ButtonGroup bg2 = new ButtonGroup();
		rb_Od = new JRadioButton("On Demand");
		rb_Od.setSelected(true);
		rb_Rr = new JRadioButton("Refresh Automatically");
		rateTF = new JTextField("5");
		label.setBounds(125,30,115,20);
		bg2.add(rb_Od);
		bg2.add(rb_Rr);
		JPanel panel2 = new JPanel();
			panel2.setLayout(null);
		panel2.setBounds(25, 170, 325,50);

		rb_Od.setBounds(5,5,85,20);
		rb_Rr.setBounds(100,5,150,20);
		rateTF.setBounds(205,30,50,20);
		panel2.add(label);
		panel2.add(rb_Od);
		panel2.add(rb_Rr);
		panel2.add(rateTF);

		StateChangedHandler sch = new StateChangedHandler();
		rb_Od.addItemListener(sch);
		rb_Rr.addItemListener(sch);


		getContentPane().add(panel2);


		panel.setLayout(null);
		panel.add(rb_Human);
		panel.add(rb_swAgent);
		panel.add(rb_Robot);

		JLabel label13 = new JLabel("Agent is ...");
		label13.setBounds(25,225, 175, 20);
		getContentPane().add(label13);
		JPanel panel1 = new JPanel();
		panel1.setBounds(25, 250, 255, 30);
		getContentPane().add(panel1);



		ButtonGroup bg1 = new ButtonGroup();
		rb_HumanClient = new JRadioButton("Human");
		rb_swClient = new JRadioButton("S/W Agent");

		bg1.add(rb_HumanClient);
		bg1.add(rb_swClient);

		rb_HumanClient.setSelected(true);
		rb_HumanClient.setBounds(5,5,75,20);
		rb_swClient.setBounds(85,5,90,20);

		panel1.setLayout(null);
		panel1.add(rb_HumanClient);
		panel1.add(rb_swClient);

		setImageControls();
		perceptFrame = new Frame1();
		cd = new ClientDisplay();
		setMenuItems();
		pack();
		validate();


	}

	private class StateChangedHandler implements ItemListener
	{
		public void itemStateChanged(ItemEvent e)
		{
			setImageControls();
		}
	}
	private void setImageControls()
	{
		if(rb_Od.isSelected())
		{
			rateTF.setEnabled(false);
		}
		else
		{
			rateTF.setEnabled(true);

		}
	}
	public void setMenuItems()
	{
		perceptMenuItem.setEnabled(false);
	}

	public void setMenuItemsGS()
	{
		perceptMenuItem.setEnabled(true);
		rb_Human.setEnabled(false);
		rb_swAgent.setEnabled(false);
		rb_Robot.setEnabled(false);
		fcfs = true;
		rb_HumanClient.setEnabled(false);
		rb_swClient.setEnabled(false);
	}

	public void setMenuItemsGE()
	{
		perceptMenuItem.setEnabled(false);
		rb_Human.setEnabled(true);
		rb_swAgent.setEnabled(true);
		rb_Robot.setEnabled(true);

		rb_HumanClient.setEnabled(true);
		rb_swClient.setEnabled(true);
		cd.setStartLoc(null);
		cd.setCurrentLocation(null);
		fcfs =true;
		if(f!=null)
			f.setVisible(false);

	}
	private class ActionHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			if(e.getSource()==planMnuItem)
			{
				if(planMnuItem.getText().equals("Display Layout"))
				{


					cd.setSize(675,680);
					cd.show();

					//planMnuItem.setText("Hide Layout");

				}
				else
				{
					cd.hide();
					planMnuItem.setText("Display Layout");
				}


			}

			if(e.getSource()==btn_Connect)
			{
				if(btn_Connect.getText().equals("Connect"))
				{
					try
					{


						if(cd.getStartLoc()==null)
						{
							JOptionPane.showMessageDialog(null, "Please choose the starting location where you want to start the game..");
							return;
						}

						try
						{
							int x = Integer.parseInt(rateTF.getText());
							// Max refresh rate is 5 minutes
							if(x <= 0 || x >=301)
							{
								JOptionPane.showMessageDialog(null, "Refresh rate can be an integer[1..300] seconds");
								return;
							}
						}
						catch(NumberFormatException nfe)
						{
							JOptionPane.showMessageDialog(null, "Refresh rate can be an integer[1..300] seconds");
							return;

						}

						if(rb_HumanClient.isSelected())
						{
							client = new String("Human");
						}
						else
						{
							client = new String("s/w Agent");
						}

						if(rb_Human.isSelected())
						{
							wwAgent = new String("Human");
						}
						else
						{
							if(rb_Robot.isSelected())
							{
								wwAgent = new String("Robot");
							}
							else
							{
								wwAgent = new String("s/w Avataar");
							}
						}
						int portNo = Integer.parseInt(tf_wwServerPort.getText());
						Socket socket = new Socket(InetAddress.getByName(tf_wwServerIP.getText()), portNo);

						cThread = new ClientThread(socket);
						cThread.start();
						//String message = new String();
						btn_Connect.setText("Disconnect");
						setMenuItemsGS();


						/*Socket socket = new Socket(InetAddress.getByName("129.107.12.16"), 255); //portNo);
						System.out.println("Connection established");*/


					}
					catch(NumberFormatException e2)
					{
						JOptionPane.showMessageDialog(null, "Please enter an integer greater than zero for port number");

					}
					catch(IOException e1)
					{
						JOptionPane.showMessageDialog(null, "Invalid IP address of Wumpus World Server. Please check");
					}

				}
				else
				{
					/* Let the WWServer know that the connection is closed and
					   agent is withdrawing from the game
					*/
					btn_Connect.setText("Connect");
					setMenuItemsGE();
					perceptFrame.hide();
					cd.hide();
					if(f!=null)
					{
						System.out.println("Hello");
						f.setVisible(false);
					}
					try
					{
						input.close();
						output.close();
					}
					catch(IOException ioe)
					{
					}
				}
			}

			if(e.getSource()==perceptMenuItem)
			{
				if(client.equals("s/w Agent"))
				{
					perceptFrame.setSW_Agent(false);
				}
				else
				{
					perceptFrame.setSW_Agent(true);
				}
				perceptFrame.setSize(620,680);
				perceptFrame.setVisible(true);
			}

		}


	}

	public void closeImageConnection()
	{
		System.out.println("closing image connection");
		tc.stopThread();
		ThreadControl.receive.closeReception();
		ThreadControl.receive = null;
		fstop.dispose();

	}

	public void setG_Client(Receive r)
	{
		r.setG_Client(this);
	}





	private class ClientThread extends Thread
	{
		Socket socket;
		private int noofTrials;
		private int currentTrial=1;

		private int maxSteps;
		private int currentStep=1;
		Frame2 f =null;
		private int timeoutLimit;
    /*
     	Resets the starting location and then resets the timeout interval of the socket
    */
	public void resetPosition() throws SocketException
	{


		cd.setCurrentLocation(cd.getStartLoc());


		perceptFrame.getCommandStatus().append("\n Trial #: " + currentTrial +", Your score = " + perceptFrame.getScore());

		Directions d = new Directions(cd.getOrgOrientation());
		perceptFrame.getCommandStatus().append("\n\nYour start location is [" + cd.getStartLoc().getX() +", " + cd.getStartLoc().getY() +"] and Orientation is " + d);

		// Here the agent needs to wait for other agents to finish their trial
		// This can take a long time. Hence, we set up a time within which a
		// trial can get over.
		perceptFrame.setGUIComponents();
		if(!fcfs)
			socket.setSoTimeout(timeoutLimit);
		else
			socket.setSoTimeout(maxSteps*60*1000);

		if (f!= null)
			f.hide();


	}
		public ClientThread(Socket s)
		{
			socket = s;
			try
			{
				// Socket will timeout in 1 minutes
				socket.setSoTimeout(60*1000);
				output = new ObjectOutputStream(socket.getOutputStream());
				input  = new ObjectInputStream(socket.getInputStream());


				perceptFrame.setOutputSocket(output);
				perceptFrame.setInputSocket(input);
			}
			catch(IOException e)
			{
				System.out.println("Error : Cannot open the connection...");
				System.exit(1);
			}
		}

		public void run()
		{

			String message=null;
			try
			{
				output.writeObject("\tAgent:" + client + ",Wumpus World Avataar:" + wwAgent + ",Starting Location:" + cd.getStartLoc().getX()+ ","+ cd.getStartLoc().getY()+ ", Orientation:"+cd.getOrientation());
				output.flush();


				System.err.println("Test");
				ConInfo ci = (ConInfo) input.readObject();
				message = ci.getMsg();
				System.out.println(message);

				if(message.equals("Not a valid starting location"))
				{
					JOptionPane.showMessageDialog(null, "Please select another starting location as it may be occupied, deadly or inaccessible..");
					cd.setStateBtn(true);
					cd.setStartLoc(null);
					cd.setCurrentLocation(null);
					output.close();
					input.close();
					setMenuItemsGE();
					return;

				}
				if(message.equals("Robots Not Available"))
				{
					JOptionPane.showMessageDialog(null, "All robots are already in the game...");
					cd.setStateBtn(true);
					cd.setStartLoc(null);
					cd.setCurrentLocation(null);
					output.close();
					input.close();
					setMenuItemsGE();
					return;
				}
				else
				if(message.equals("Humans Not Available"))
				{
					JOptionPane.showMessageDialog(null, "All Humans Avatars are already in the game");
					cd.setStateBtn(true);
					cd.setStartLoc(null);
					cd.setCurrentLocation(null);
					output.close();
					input.close();
					setMenuItemsGE();
					return;
				}
				if(message.equals("Game in progress"))
				{
					JOptionPane.showMessageDialog(null,"Game is in progress, check back later....");
					cd.setStateBtn(true);
					cd.setStartLoc(null);
					cd.setCurrentLocation(null);
					output.close();
					input.close();
					setMenuItemsGE();
					return;
				}
				else if(message.equals("Already Occupied Location"))
				{
					JOptionPane.showMessageDialog(null, "The starting location is already occupied. Please change the starting location..");
					cd.setStateBtn(true);
					cd.setStartLoc(null);
					cd.setCurrentLocation(null);
					output.close();
					input.close();
					setMenuItemsGE();
					return;
				}
				else
				{
					resetPosition();
					JOptionPane.showMessageDialog(null, message);
					if(message.equals("Request Accepted Successfully, Round Robin Scheme"))
					{
						timeoutLimit = ci.getTimeoutLimit();
						socket.setSoTimeout(ci.getTimeoutLimit());
						fcfs = false;
					}

					perceptFrame.setMaxStepsText(""+ci.getMaxSteps());
					perceptFrame.setNoofTrialsText(""+ci.getNumberOfTrials());
					perceptFrame.setCurrentStepText("1");
					perceptFrame.setCurrentTrialText("1");

					maxSteps = ci.getMaxSteps();
					noofTrials = ci.getNumberOfTrials();
					currentStep = 1;
					currentTrial = 1;

					// If the human agent is playing the game
					// and the avataar is either a human or a robot
					// then obtain the connection with the human or robot avatar
					// to obtain the image percept
	if(rb_HumanClient.isSelected() && (rb_Human.isSelected() || rb_Robot.isSelected()))
	{
					if(rb_Rr.isSelected())
					{
						System.out.println("Auto Refresh Selected!!!");



						// For the time being this is hard coded!!
						// This opens the connection with the Avataar and then
						// starts the reception, so that the ThreadControl object
						// tc can get in the run method and receive frames!!
						//Reception reception = new Reception("129.107.55.245", 255,rateTF.getText());
						Reception reception = new Reception(ci.getIP(), ci.getPort(),rateTF.getText());

						if(reception.openConnection()==true)
						{
							setG_Client(ThreadControl.receive);
							// Instantiating the Thread Control!
							// This just starts a Thread that waits to startReception!!
							tc = new ThreadControl();
							//tc.start();
							System.out.println("Connection opened with avataar");
							// This is the frame that contains the stop button.
							// When this button is pressed, the snap shots should be stopped.
							// There should be a way to restart the transmission too!!
							fstop = new Frame("Stop");
							final Button bstop = new Button("Stop");
							fstop.add(bstop);
							fstop.setVisible(true);
							bstop.addActionListener(
								new ActionListener()
								{
									public void actionPerformed(ActionEvent e)
									{

										int choice = JOptionPane.showConfirmDialog(null,
											"Do you really want to stop the reception!", "Stop Reception", JOptionPane.YES_NO_OPTION);

										if(choice==0) //0=>YES
										{
											closeImageConnection();
											/*tc.stopThread();
											ThreadControl.receive.closeReception();
											ThreadControl.receive = null;
											fstop.dispose();*/
										}

									}
								}
								);

							fstop.addWindowListener(
								new WindowAdapter()
								{
									public void windowClosing(WindowEvent e)
									{
										closeImageConnection();

									}
								}
								);

							fstop.setSize(100,50);
							fstop.validate();
						}
						else
						{
							// Connection with avataar failed => Cannot get Image Percepts
							JOptionPane.showMessageDialog(null, "Error : Cannot get Image Percepts from the avataar");
						}
					}
					else
					{

						od = new OnDemandDlg();//new JFrame(), false);
						//od.setIP_Port("129.107.55.245", 255);
						od.setIP_Port(ci.getIP(), ci.getPort());
						if(!od.openConnection())
						{
							JOptionPane.showMessageDialog(null, "Could not obtain connection from the avataar in wumpus world");
							od.dispose();
						}
						else
						{
							od.setSize(250,70);
							od.setVisible(true);
							od.validate();
						}


					}
	} // End of if statement for human agent
	else
	{
		// This is when the agent is software agent. This requires some additional coding
	}

					cd.setStateBtn(false);
					message = null;
				// This should be shown if we are using a software avatar

				if(rb_swAgent.isSelected())
				{
					f = new Frame2();
					f.setSize(100,100);
					f.show();
				}
					do
					{
						try
						{

							/*message = (String)input.readObject();
							System.out.println(message);
							if(message.equals("SERVER >> TERMINATE"))
							{

								JOptionPane.showMessageDialog(null, "Server terminated connection!!");
							}
							else*/
							{
								//wP.ConInfo t1 = (wP.ConInfo) input.readObject();
								//System.out.println(t1.getHint());

								//wP.TransferPercept t = (wP.TransferPercept) input.readObject();

								// Percept is being received here
								ConInfo t = (ConInfo) input.readObject();

								// Socket will timeout in 2 min
								if(!fcfs)
									socket.setSoTimeout(timeoutLimit);
								else
									socket.setSoTimeout(60*1000);
								// Enabling the button to send the action to the server
								perceptFrame.getActionButton().setEnabled(true);

								currentStep = t.getCurrentStep();
								currentTrial = t.getCurrentTrial();

								System.out.println(t.getHint());
								perceptFrame.setHintText(t.getHint());
								if(t.getStench())
								{
									perceptFrame.setStenchText("Yes");
								}
								else
								{
									perceptFrame.setStenchText("No");
								}
								if(t.getBreeze())
								{
									perceptFrame.setBreezeText("Yes");
								}
								else
								{
									perceptFrame.setBreezeText("No");
								}
								if(t.getGlitter())
								{
									perceptFrame.setGlitterText("Yes");
								}
								else
								{
									perceptFrame.setGlitterText("No");
								}
								if(t.getBump())
								{
									perceptFrame.setBumpText("Yes");
								}
								else
								{
									perceptFrame.setBumpText("No");
								}
								if(t.getScream())
								{
									perceptFrame.setScreamText("Yes");
								}
								else
								{
									perceptFrame.setScreamText("No");
								}

								perceptFrame.setCurrentStepText(""+t.getCurrentStep());
								perceptFrame.setCurrentTrialText(""+t.getCurrentTrial());

								perceptFrame.setScoreText(new String(""+t.getScore()));
								perceptFrame.setArrowText(new String(""+t.getNumArrow()));
								perceptFrame.setGoldPiecesText(new String(""+t.getNumGold()));
								perceptFrame.setAgentStatusText(new ActorState(t.getStatus()).toString());
								perceptFrame.setLastActionText(Action.toString(t.getActionTaken()));



								// display image when software agent is being used
								if(rb_swAgent.isSelected())
								{
									f.makeImage(t);
									f.setVisible(true);
								}


								if(currentStep > maxSteps)
								{
									if(currentTrial >= noofTrials)
									{
										JOptionPane.showMessageDialog(null, "End of game");
										btn_Connect.setText("Connect");
										setMenuItemsGE();
										if(f!=null)
											f.hide();

										break;
									}
									else
									{
										JOptionPane.showMessageDialog(null, "Trial Over, starting a new one");
										perceptFrame.getCommandStatus().append("\nYou exhausted all steps in the last trial. Waiting to start a new trial");
										resetPosition();
										continue;
									}
								}

								message = (String)input.readObject();
								System.out.println(message);

								// Setting action button back to enabled
								if(!fcfs)
									perceptFrame.getActionButton().setEnabled(false);
								else
									perceptFrame.getActionButton().setEnabled(true);

								if(message.equals("Disconnecting"))
								{
										JOptionPane.showMessageDialog(null,"Connection terminated as action not sent twice consecutively");
										btn_Connect.setText("Connect");
										setMenuItemsGE();
										//perceptFrame.hide();
										//cd.hide();
										if(f!=null)
											f.hide();

										break;

								}
								if(message.equals("Game Over"))
								{
									perceptFrame.getCommandStatus().append("\nOops!! Game over as you moved into a wumpii or fell into a pit!");									//currentTrial++;
									ConInfo t1 = (ConInfo) input.readObject();
									perceptFrame.setScoreText(new String(""+t1.getScore()));
								    perceptFrame.setHintText(t1.getHint());
									perceptFrame.setAgentStatusText(new ActorState(t1.getStatus()).toString());
									perceptFrame.setLastActionText(Action.toString(t1.getActionTaken()));
									perceptFrame.setCurrentStepText(""+t1.getCurrentStep());


									JOptionPane.showMessageDialog(null, "You are defeated...");

									//currentTrial++;
									if(currentTrial >=  noofTrials)
									{
										JOptionPane.showMessageDialog(null, "End of game");


										btn_Connect.setText("Connect");
										setMenuItemsGE();
										//perceptFrame.hide();
										//cd.hide();
										if(f!=null)
											f.hide();

										break;
									}
									else
									{
										JOptionPane.showMessageDialog(null, "Trial Over, starting a new one...");
										perceptFrame.getCommandStatus().append("\nYou lost the last trial. Waiting to start a new one");
										resetPosition();
										continue;
									}
								}
								if(message.equals("Success"))
								{
										String s = (String) input.readObject();
										System.out.println(s);
										StringTokenizer st = new StringTokenizer(s," ");
										Cell_Client cc = new Cell_Client(Double.parseDouble(st.nextToken())*6, Double.parseDouble(st.nextToken())*6);
										System.out.println(cc.getX()+", "+ cc.getY());
										perceptFrame.getCommandStatus().append("\nSuccessful!");
										perceptFrame.getCommandStatus().append("\nCurrent Location : [" + cc.getX() + ", "+ cc.getY()+"]");
										//cc.setX();
										//cc.setY();
										String orientation = new String(st.nextToken());
										switch(Integer.parseInt(orientation))
										{
											case 1:
													perceptFrame.getCommandStatus().append(" Orientation : NORTH");
											 		break;
											case 2:
													perceptFrame.getCommandStatus().append(" Orientation : EAST");
													break;
											case 3:
													perceptFrame.getCommandStatus().append(" Orientation : SOUTH");
													break;
											case 4:
													perceptFrame.getCommandStatus().append(" Orientation : WEST");
													break;
										}

										cd.setOrientation(Integer.parseInt(orientation));
										cd.setCurrentLocation(cc);
										cd.repaint();
								}
								if(message.equals("Climbed Out"))
								{
									perceptFrame.getCommandStatus().append("\nYou have successfully climbed out. Congratulations!!");
									//currentTrial++;
									ConInfo t1 = (ConInfo) input.readObject();
									perceptFrame.setScoreText(new String(""+t1.getScore()));
								    perceptFrame.setHintText(t1.getHint());
									perceptFrame.setAgentStatusText(new ActorState(t1.getStatus()).toString());
									perceptFrame.setLastActionText(Action.toString(t1.getActionTaken()));
									perceptFrame.setCurrentStepText(""+t1.getCurrentStep());

									if(currentTrial >=  noofTrials)
									{
										JOptionPane.showMessageDialog(null, "End of game");
										btn_Connect.setText("Connect");
										setMenuItemsGE();
										//perceptFrame.hide();
										//cd.hide();
										if(f!=null)
											f.hide();

										break;
									}
									else
									{
										JOptionPane.showMessageDialog(null, "Trial Over, starting a new one");
										perceptFrame.getCommandStatus().append("\nYou won the last trial. Waiting to start a new trial");
										resetPosition();
										if(f!=null)
										 f.hide();
										continue;
									}

								}
								if(message.equals("No Wumpus Shot"))
								{
									perceptFrame.getCommandStatus().append("\nNo Wumpus Shot!");
								}
								if(message.equals("Out of Arrows"))
								{
									perceptFrame.getCommandStatus().append("\nUnsuccessful, out of arrows...");
								}
								if(message.equals("Shot Wumpus"))
								{
									perceptFrame.getCommandStatus().append("\nWumpus has been shot...");
								}
								if(message.equals("Invalid Location"))
								{
									perceptFrame.getCommandStatus().append("\nUnsuccessful, tried to move into an invalid location...");
								}
								if(message.equals("No Gold Found"))
								{
									perceptFrame.getCommandStatus().append("\nUnsuccessful, no gold found at current location...");
								}
								if(message.equals("Not Starting Location"))
								{
									perceptFrame.getCommandStatus().append("\nUnsuccessful, Please move to starting location to climb out of wumpus world");
									//message = (String) input.readObject();
								}
								if(message.equals("Not Implemented"))
								{
									perceptFrame.getCommandStatus().append("\n This action has not been implemented yet");
								}
							}

						}
						catch(ClassNotFoundException cnfex)
						{
						}

					} while(true);//!message.equals("SERVER >> TERMINATE"));

					btn_Connect.setText("Connect");
					setMenuItemsGE();
					perceptFrame.hide();
					cd.hide();
					input.close();
					output.close();

				}
			}

			catch(InterruptedIOException iioex)
			{
				JOptionPane.showMessageDialog(null,"The operation timed out. Disconnecting from the server. Please reconnect");
				perceptFrame.getCommandStatus().append("\nThe operation timed out. Please reconnect to the server");
				btn_Connect.setText("Connect");
				setMenuItemsGE();
				if(f!=null)
				 f.hide();
				//perceptFrame.hide();
				//cd.hide();
				try
				{
					input.close();
					output.close();
				}
				catch(IOException ioe)
				{
				}
			}
			catch(ClassNotFoundException cnfex)
			{
			}
			catch(IOException ioex)
			{

			}


		}
	}
	public static void main(String args[])
	{
		G_Client c = new G_Client();
		c.setSize(315,345);
		c.show();

	}

	public class OnDemandDlg extends JFrame implements ActionListener
	{
		private JButton getImageBtn;
		private JButton closeConBtn;
		private String IP;
		private int portNumber;
		private ObjectInputStream is;
		private ObjectOutputStream os;
		private Receive r;
		public OnDemandDlg()//JFrame frame, boolean modal)
		{
			//super (frame, modal);
			setTitle("Obtain Image Percept");
			getImageBtn = new JButton("Get Image");
			getImageBtn.setBounds(10,10 ,105,25);
			getImageBtn.addActionListener(this);
			closeConBtn = new JButton("Close");
			closeConBtn.setBounds(125,10,105,25);
			getContentPane().setLayout(null);
			getContentPane().add(getImageBtn);
			getContentPane().add(closeConBtn);
			closeConBtn.addActionListener(this);

			addWindowListener(
				new WindowAdapter()
				{
					public void windowClosing(WindowEvent e)
					{
						r.closeReception();
						closeWindow();
					}
				}
				);
		}

		public void closeWindow()
		{
			r = null;
			dispose();
		}
		public void sendDummyData()
		{
			try
			{
				if(os==null)
				{
					System.out.println("Outputstream is null!!");
				}
				else

					os.writeObject("DUMMY");
			}
			catch(Exception e)
			{
			}
		}
		public void actionPerformed(ActionEvent e)
		{
			if(e.getSource() == getImageBtn)
			{
				/* Do something here!!!*/


				sendDummyData();

				r.getOneFrame();


			/*catch(IOException ioex)
			{
			}*/
			}
			else
			{

				int choice = JOptionPane.showConfirmDialog(null,
					"Do you really want to stop the reception!", "Stop Reception", JOptionPane.YES_NO_OPTION);

				if(choice==0) //0=>YES
				{
					r.closeReception();
					//hide();
					dispose();
				}
			}

		}


		public void setIP_Port(String ip, int port)
		{
			IP = ip;
			portNumber = port;
		}

		public boolean openConnection()
		{
			try
			{
				Socket s = new Socket(InetAddress.getByName(IP), portNumber);
				os = new ObjectOutputStream(s.getOutputStream());
				is = new ObjectInputStream(s.getInputStream());
				os.writeObject("ON DEMAND");
				os.flush();
				r = new Receive (is,os,portNumber, this);
				setG_Client(r);

			}
			catch(Exception e)
			{
				return false;
			}
			return true;
		}
	}
}