/****************************************************************************
Programmer: Srinath Sridhar
Project Wise
- Thread that waits for connection/activity on the hard-coded ports.
- Uses ThreadControl to start receiving frames once activity on a port is detected
****************************************************************************/

import java.io.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.*;
import java.awt.image.*;


public class Reception extends Frame {
    int portno;
    String IP;
    ObjectInputStream ois;
    ObjectOutputStream oos;
    ImageViewer iv;
    InputStream is;
    Thread t;
    String message;
    static boolean b = true;

    Reception(String ip, int port, String msg) {
        System.out.println("Requesting Connections on port: " + port);
        System.out.println("IP = " + ip + ", Port = " + port);
        portno = port;
        IP = new String(ip);
        message = msg;

    }

    public boolean openConnection() {
        try {



            Socket s = new Socket(InetAddress.getByName(IP), portno);
            oos = new ObjectOutputStream(s.getOutputStream());
			ois = new ObjectInputStream(s.getInputStream());

			oos.writeObject(message);	// Sending whether the transmission required is
										// on demand or at refresh rate

            System.err.println("Receiving Frames From Port: " + portno);

            ThreadControl.startReception(ois,oos,portno);
            System.out.println("Openning connections with Avataar");
            }
        catch(Exception e)
            {
				System.out.println("Error : Could not open connections with the avataar");
				return false;
			}

			return true;
    }


    public void finalize() {
        System.err.println("Destroying Object");
    }
}
